# Guide utilisateur (French)

Version du logiciel concernée: v0.15.0.

*Cette version devrait contenir les mêmes fonctionnalités que la v1.0.0. Il n'y aura donc pas besoin de mise à jour pour la v1.0. Les principales évolutions prévues après cela devraient concerner le design de l'application, ce qui necessitera une mise à jour des images inclues.*

## Fonctionnalités principales du logiciel

Le premier but du logiciel est d'offrir une outil pour suivre dans le temps des objectifs. C'est un outil générique, configurable, que l'utilisateur peut adapter à ses besoins. Parmi les usages standards pensés à l'origine on trouve:

* Suivre son avancement dans un programme sportif (lister des objectifs à cocher)
* Ne pas oublier ses erreurs (marquer ses faiblesses pour les surmonter)
* Encourager les comportements positifs (ne pas oublier qu'on réussit des choses)

## License, engagements

LifePex est un logiciel sous license GPLv3, une license dite "libre". Elle ne comporte aucune garantie que le logiciel lui-même est sans faille ni d'un support quelconque. Il est developpé benevolement. Enfin, vous avez le droit de lire le code source, le modifier et le redistribué, sous reserve que cela soit fait sous license GPLv3 (ou compatible).

L'administrateur de l'hebergement de LifePex devrait s'engager à ne jamais accéder aux données personnelles stoquées par les utilisateurs de l'instance sans l'accord explicite et individuel de l'utilisateur concerné. Il devrait également s'engager à s'assurer de la mise à jour du logiciel afin de corriger toute faille corrigée pour protéger les utilisateurs qui lui font confiance.

L'administrateur devrait également s'engager à ne jamais installer de système de traçage de ses utilisateurs. Tout besoin de suivi de charge ou de sécurité ne devrait jamais prendre le pas sur la vie privée de ses utilisateurs.

## Tour du logiciel

LifePex est un logiciel qui a avant tout pour objectif d'être utilisé sur mobile.
Cependant nous faisons attention à ce que toutes les fonctionnalités soient disponible sur mobile et ordinateur.

### 1. Barre de navigation (invité)

Toute page importante du logiciel est accessible via la barre de navigation.
Celle-ci est accessible en cliquant sur le bouton en haut à droite de l'écran.

En temps qu'utilisateur non enregistré vous n'avez pas encore accès à beaucoup de pages.
Cliquez sur s'enregistrer ("Register") pour passer à la suite.

![](https://git.sceptique.eu/attachments/00c81464-06bd-446d-bbb8-f347bc574d2d)


### 2. Enregistrement d'un nouveau compte

La première étape de la création d'un nouveau compte est d'entrer un nom d'utilisateur que vous voulez utiliser pour s'identifier, et un mot de passe que seul vous pouvez connaitre. Cela vous permettra l'empêcher tout autre utilisateur d'accéder à vos données. Le boutton en fin de page permet de valider la création de son compte.
Cela vous connectera automatiquement.

![](https://git.sceptique.eu/attachments/5dc654cd-f8aa-44ea-b7e5-8f3b0bf4eb67)

*Attention: le logiciel ne dispose pas de votre addresse email à ce stade, il est donc impossible de retrouver un mot de passe oublié.*

### 3. Connexion à un compte existant

Si vous avez déjà un compte cependant, vous pouvez également utiliser le bouton de connexion dans la barre de navigation pour accéder à la page correspondante. Entrez simplement votre nom d'utilisateur et mot de passe renseigné lors de la création de votre compte pour accéder à votre compte et validez le formulaire.

![](https://git.sceptique.eu/attachments/85e9b4cb-de9b-4335-ba5b-2f1b94557606)

### 4. Page principale (aujourd'hui)

La page principale vous donne accès à votre tableau de bord. C'est là que vous pouvez valider un point dans une des lignes (parfois ppellées "pex"). Appuyez sur le bouton + ou - de la ligne pour augmenter le nombre de validations de la journée.

![](https://git.sceptique.eu/attachments/ba3fd0b0-1a72-496b-aec5-9fe46541b83f)

#### 4.1 Ajout d'un nouveau pex

Si vous souhaitez ajouter une nouvelle ligne, il est possible d'appuyer sur le gros boutton vert en bas à droit de la page principale. Cela vous amènera sur un formulaire contenant un champs pour le nom, la catégorie, et le nombre de "xp" que chaque validation de ce pex vous apportera. Les xp sont une valeur relative utilisée pour comparer la valeur de 2 pex.

![](https://git.sceptique.eu/attachments/bcf313ec-ee32-4a20-ba86-c2d24ce91426)

### 5. Barre de navigation (avec un compte)

La barre de navigation, toujours accessible via le boutton en haut à droite de l'écran permet maintenant d'accéder à de nombreuses pages.

![](https://git.sceptique.eu/attachments/890c50a1-c6d1-4474-b756-8e6d5cdac76b)

### 6. Récapitulatif

La page de récapitulatif, via la barre de navigation et le boutton "Recap" permet d'avoir accès en 1 coup d'oeil plusieurs informations:

* Votre niveau et votre xp accumulé en se basant sur les "xp" évoqué en #4.1

* Le progrès dans le temps de vos différentes catégories. Il est possible de cliquer sur la légende pour faire apparaitre ou disparaitre une des ligne du graphique.

* Vos accomplissements validés et leurs médailles respectives.

![](https://git.sceptique.eu/attachments/ddc33b93-f660-4991-87f4-7e4e6a382e16)

### 7. Les accomplissements

![](https://git.sceptique.eu/attachments/1803bf3b-633f-49bb-a079-0adf7b12f03c)

### 8. Ajout d'accomplissement

![](https://git.sceptique.eu/attachments/88362fae-0823-4373-9861-82872057a8a0)

### 9. Page principale, options avancées

![](https://git.sceptique.eu/attachments/abf52606-f1b4-45cd-9ca6-53ef7b33c889)
