class LifePex::AchievementDSL::Success::Parameter
  include LifePex::AchievementDSL::Dslize
  dslize_input :name
  dslize_input :type
  dslize_input :description
  dslize_flag :required

  def initialize(name, type = nil, &block)
    @name = name
    @type = type
    @description = nil
    instance_eval(&block) if block_given?
  end

  # not dsl related
  def accept?(v)
    return true if @input_type.nil?
    return true if @input_type == :Numeric && v.is_a?(Numeric)
    return true if @input_type == :Integer && v.is_a?(Numeric) && v.round(0) == v
    return true if @input_type == :String && v.is_a?(String)
    return true if @input_type == :Array && v.is_a?(Array)
    return false
  end
end
