class LifePex::AchievementDSL::Success::Setup
  include LifePex::AchievementDSL::Dslize
  dslize_input :icon
  dslize_input :name

  attr_reader :success # FIXME: why cannot put success as dsl input ?
  attr_reader :parameters

  def initialize(success, name, &block)
    @success = success
    @name = name
    @parameters = {}
    @icon = nil
    instance_eval(&block)
  end

  def parameter(**kv)
    param_name = kv.keys.first.to_s
    param_value = kv.values.first
    param = @success.parameters.find { |param| param.name == param_name }
    raise RuntimeError.new "Invalid value #{param_value} for #{param_name}" unless param_value.nil? && !param.is_required || param.accept?(param_value)
    @parameters[param_name] = param_value
  end

  def call(user_pexs, pexs)
    to_complete = @success.get_to_complete
    instance_exec user_pexs, pexs, &to_complete
  end

  def given(name)
    @parameters[name.to_s]
  end

  module Medal
    def medal
      if self.icon == "gold"
        "&#129351;"
      elsif self.icon == "silver"
        "&#129352;"
      elsif self.icon == "copper" || self.icon == "bronze"
        "&#129353;"
      else
        "&#127941;"
      end
    end
  end
  include Medal
end
